/*
 * Copyright (c) y2k Micha Moskal <malekith@topnet.pl>
 *
 * This file is part of cryptoFTP - cftp protocol implementation.
 * CryptoFTP is free software. You can redistribute it and/or modify it under
 * the terms of the GNU General Public License (see COPYING.GPL for details).
 *
 * $Id: getpass.c,v 1.1.1.1 2000/04/22 10:15:53 malekith Exp $
 */

#include "config.h"
#include "utils.h"

#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <string.h>


/* #define ECHO_CHAR "-" */

char *x_get_pass()
{
	char line[200], c;
	int pos = 0, dead = 0;
	struct termios tattr, tattr_s;

	fflush(stdout);

	if (isatty(0)) {
		tcgetattr(0, &tattr_s);
		tcgetattr(0, &tattr);
		tattr.c_lflag &= ~(ICANON | ECHO);
		tattr.c_cc[VMIN] = 1;
		tattr.c_cc[VTIME] = 0;
		tcsetattr(0, TCSAFLUSH, &tattr);
	}

	line[0] = 0;

	while (!dead) {
		if (read(0, &c, 1) <= 0)
			break;
		switch (c) {
		case 3:	/* ^c */		
		case 4:	/* ^d */
			dead = 2;
			break;
		case 10:	/* \n */
		case 13:	/* \r */		
			dead = 1;
			break;
		case 127:
		case 8:
			if (pos) {
				pos--;
#ifdef ECHO_CHAR
				write(1, "\b \b", 3);
#endif
				line[pos] = 0;
			}
			break;
		default:
			if (pos > (int) sizeof(line) - 10)
				dead = 1;
			else {
				line[pos++] = c;
				line[pos] = 0;
#ifdef ECHO_CHAR
				write(1, ECHO_CHAR, 1);
#endif
			}
			break;
		}
	}
	write(1, "\r\n", 2);

	if (isatty(0))
		tcsetattr(0, TCSAFLUSH, &tattr_s);

	if (dead == 1)
		return xstrdup(line);
	else
		return 0;
}
